// DetailTypeWMVDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailTypeWMVDlg.h"
#include "afxdialogex.h"


// CDetailTypeWMVDlg _CAO

IMPLEMENT_DYNAMIC(CDetailTypeWMVDlg, CDialog)

//CDetailTypeWMVDlg::CDetailTypeWMVDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(IDD_DETAIL_TYPE_WMV, pParent)
//{
//
//}

CDetailTypeWMVDlg::CDetailTypeWMVDlg(sl::TypeConfig::WMV& wmv)
	: CDialog(CDetailTypeWMVDlg::IDD, NULL)
	, wmv_(wmv)
{

}

CDetailTypeWMVDlg::~CDetailTypeWMVDlg()
{
}

void CDetailTypeWMVDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_PACKET_ENABLE, m_xcCheckPacketEnable);
	DDX_Control(pDX, IDC_EDIT_PACKET_TIME, m_xcEditPacketTime);
	DDX_Control(pDX, IDC_SPIN_PACKET_TIME, m_xcSpinPacketTime);
	DDX_Control(pDX, IDC_CHECK_FRAME_ENABLE, m_xcCheckFrameEnable);
	DDX_Control(pDX, IDC_EDIT_FRAME_TIME, m_xcEditFrameTime);
	DDX_Control(pDX, IDC_SPIN_FRAME_TIME, m_xcSpinFrameTime);
}

void CDetailTypeWMVDlg::InitControls()
{
	m_xcCheckPacketEnable.SetCheck(wmv_.packet.enable ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinPacketTime.SetPos32(wmv_.packet.time);
	m_xcEditPacketTime.EnableWindow(wmv_.packet.enable ? TRUE : FALSE);
	m_xcSpinPacketTime.EnableWindow(wmv_.packet.enable ? TRUE : FALSE);

	m_xcCheckFrameEnable.SetCheck(wmv_.frame.enable ? BST_CHECKED : BST_UNCHECKED);
	m_xcSpinFrameTime.SetPos32(wmv_.frame.time);
	m_xcEditFrameTime.EnableWindow(wmv_.frame.enable ? TRUE : FALSE);
	m_xcSpinFrameTime.EnableWindow(wmv_.frame.enable ? TRUE : FALSE);
}


BEGIN_MESSAGE_MAP(CDetailTypeWMVDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailTypeWMVDlg::OnBnClickedBtnAllDefault)
	ON_BN_CLICKED(IDC_CHECK_PACKET_ENABLE, &CDetailTypeWMVDlg::OnBnClickedCheckPacketEnable)
	ON_BN_CLICKED(IDC_CHECK_FRAME_ENABLE, &CDetailTypeWMVDlg::OnBnClickedCheckFrameEnable)
END_MESSAGE_MAP()


// CDetailTypeWMVDlg bZ[W nh[


BOOL CDetailTypeWMVDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcSpinPacketTime.SetRange32(1000, 600000);
	m_xcSpinFrameTime.SetRange32(1000, 600000);

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
				  // O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailTypeWMVDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailTypeWMVDlg::OnDestroy()
{
	CDialog::OnDestroy();

	wmv_.packet.enable = m_xcCheckPacketEnable.GetCheck() == BST_CHECKED;
	wmv_.packet.time = m_xcSpinPacketTime.GetPos32();

	wmv_.frame.enable = m_xcCheckFrameEnable.GetCheck() == BST_CHECKED;
	wmv_.frame.time = m_xcSpinFrameTime.GetPos32();
}


void CDetailTypeWMVDlg::OnBnClickedBtnAllDefault()
{
	wmv_ = sl::TypeConfig::WMV();

	InitControls();
}


void CDetailTypeWMVDlg::OnBnClickedCheckPacketEnable()
{
	wmv_.packet.enable = m_xcCheckPacketEnable.GetCheck() == BST_CHECKED;
	m_xcEditPacketTime.EnableWindow(wmv_.packet.enable ? TRUE : FALSE);
	m_xcSpinPacketTime.EnableWindow(wmv_.packet.enable ? TRUE : FALSE);
}


void CDetailTypeWMVDlg::OnBnClickedCheckFrameEnable()
{
	wmv_.frame.enable = m_xcCheckFrameEnable.GetCheck() == BST_CHECKED;
	m_xcEditFrameTime.EnableWindow(wmv_.frame.enable ? TRUE : FALSE);
	m_xcSpinFrameTime.EnableWindow(wmv_.frame.enable ? TRUE : FALSE);
}
