#pragma once

namespace sl {

////////////////////////////////////////////////////////////////////////
// ڍאݒ
struct NetworkConfig : public dsp::NetworkControl {
	NetworkConfig()
		: stop(false)
	{}
	bool stop; // vC[I`lؒf
};

// ^Cvʐݒ
struct TypeConfig : public dsp::TypeControl {
};

// fR[_
struct DecoderInfo {
	DecoderInfo()
		: enable(false)
		, name()
		, id()
	{}

	bool enable; // L
	std::wstring name; // tB^
	GUID id; // tB^ID
};

// uEU
struct BrowserConfig {
	BrowserConfig()
		: def(true)
	{}

	bool def; // ̃uEUg
	std::wstring web; // URLJWebuEU
	std::wstring bbs; // BBSuEU
};

// XibvVbg
struct SnapshotConfig {
	SnapshotConfig()
		: folder(L"snapshot")
		, format(utl::GRAPHIC_FORMAT_PNG)
		, jpegQuality(100)
		, display(false)
		, fit(false)
	{}

	std::wstring folder; // ۑtH_
	int format; // ۑ`
	int jpegQuality; // JPEGi
	bool display; // \𑜓xŕۑ
	bool fit; // ̉𑜓xkȂ
};

// BBSo[
struct BoardConfig : public bbs::BoardControl {
	// X|bvAbvʒu
	enum POPUP_POSITION {
		POPUP_POSITION_CENTER, // J[\
		POPUP_POSITION_LEFT, // J[\
		POPUP_POSITION_RIGHT, // J[\E
		POPUP_POSITION_BOTH, // J[\E
		POPUP_POSITION_COUNT, // enum
	};

	BoardConfig()
		: contact(true)
		, change(true)
		, retry(true)
		, delay(50)
		, position(POPUP_POSITION_CENTER)
		, under(false)
		, align(true)
		, order(false)
		, scroll(false)
	{}

	bool contact; // R^NgURLǂݍ
	bool change; // URLύX𔽉f
	bool retry; // gCIɃXbhXV~
	int delay; // |bvAbv
	int position; // |bvAbvʒu
	bool under; // o[̉ɂ
	bool align; // XN[cɂ͂ݏoȂ悤ɕ\
	bool order; // X]
	bool scroll; // XbhXN[]
};

// N
struct StartConfig {
	StartConfig()
		: recent(true)
	{}

	bool recent; // ŌɍĐt@CĐ
};

// I
struct EndConfig {
	EndConfig()
		: pos(true)
		, size(true)
		, aspect(false)
		, volume(true)
		, balance(false)
		, mute(true)
	{}

	bool pos; // EBhEʒuۑ
	bool size; // EBhETCYۑ
	bool aspect; // AXyNgۑ
	bool volume; // ʂۑ
	bool balance; // ʃoXۑ
	bool mute; // ~[gԂۑ
};

// ڍאݒ
struct DetailConfig {
	NetworkConfig network; // lbg[N
	TypeConfig type; // ^Cvʐݒ
	dsp::DecoderControl decoder; // fR[_
	std::vector<DecoderInfo> video; // rfIfR[_
	std::vector<DecoderInfo> audio; // I[fBIfR[_
	BrowserConfig browser; // uEU
	SnapshotConfig snapshot; // XibvVbg
	BoardConfig board; // BBSo[
	StartConfig start; // N
	EndConfig end; // I
};

} // namespace sl