#pragma once

#include "afxcmn.h"
#include "DetailNetworkGeneralDlg.h"
#include "DetailNetworkPeercast1Dlg.h"
#include "DetailNetworkPeercast2Dlg.h"

// CDetailNetworkDlg _CAO

class CDetailNetworkDlg : public CDialog
{
	DECLARE_DYNAMIC(CDetailNetworkDlg)

public:
	CDetailNetworkDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~CDetailNetworkDlg();

// _CAO f[^
	enum { IDD = IDD_DETAIL_NETWORK };

	int select_;

	struct Dialog {
		Dialog(sl::NetworkConfig& network)
			: general(network)
			, peercast1(network)
			, peercast2(network)
		{}

		CDetailNetworkGeneralDlg general;
		CDetailNetworkPeercast1Dlg peercast1;
		CDetailNetworkPeercast2Dlg peercast2;
	};

	Dialog dlg_;

	struct Item {
		CDialog* dlg;
		int idd;
		int index;
	};

	std::vector<Item> vec_;
	CRect rect_;

	sl::NetworkConfig network_;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult);

	CTabCtrl m_xcTab;
};
