// DetailNetworkPeercast2Dlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailNetworkPeercast2Dlg.h"
//#include "afxdialogex.h"


// CDetailNetworkPeercast2Dlg _CAO

IMPLEMENT_DYNAMIC(CDetailNetworkPeercast2Dlg, CDialog)

//CDetailNetworkPeercast2Dlg::CDetailNetworkPeercast2Dlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CDetailNetworkPeercast2Dlg::IDD, pParent)
//{
//
//}

CDetailNetworkPeercast2Dlg::CDetailNetworkPeercast2Dlg(sl::NetworkConfig& network)
	: CDialog(CDetailNetworkPeercast2Dlg::IDD, NULL)
	, network_(network)
{

}

CDetailNetworkPeercast2Dlg::~CDetailNetworkPeercast2Dlg()
{
}

void CDetailNetworkPeercast2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHECK_RELAY_MANUAL_RECONNECT, m_xcCheckRelayManualReconnect);
	DDX_Control(pDX, IDC_CHECK_RELAY_MANUAL_STOP, m_xcCheckRelayManualStop);
	DDX_Control(pDX, IDC_CHECK_RELAY_AUTOMATIC_RECONNECT, m_xcCheckRelayAutomaticReconnect);
	DDX_Control(pDX, IDC_CHECK_RELAY_AUTOMATIC_STOP, m_xcCheckRelayAutomaticStop);
}

void CDetailNetworkPeercast2Dlg::InitControls()
{
	m_xcCheckRelayManualReconnect.SetCheck(network_.relay.manual.reconnect ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckRelayManualStop.SetCheck(network_.relay.manual.stop ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckRelayAutomaticReconnect.SetCheck(network_.relay.automatic.reconnect ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckRelayAutomaticStop.SetCheck(network_.relay.automatic.stop ? BST_CHECKED : BST_UNCHECKED);
}


BEGIN_MESSAGE_MAP(CDetailNetworkPeercast2Dlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailNetworkPeercast2Dlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailNetworkPeercast2Dlg bZ[W nh[


BOOL CDetailNetworkPeercast2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailNetworkPeercast2Dlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailNetworkPeercast2Dlg::OnDestroy()
{
	CDialog::OnDestroy();

	network_.relay.manual.reconnect = m_xcCheckRelayManualReconnect.GetCheck() == BST_CHECKED;
	network_.relay.manual.stop = m_xcCheckRelayManualStop.GetCheck() == BST_CHECKED;
	network_.relay.automatic.reconnect = m_xcCheckRelayAutomaticReconnect.GetCheck() == BST_CHECKED;
	network_.relay.automatic.stop = m_xcCheckRelayAutomaticStop.GetCheck() == BST_CHECKED;
}


void CDetailNetworkPeercast2Dlg::OnBnClickedBtnAllDefault()
{
	auto tmp = sl::NetworkConfig();

	network_.rebuild.wait = tmp.rebuild.wait;
	network_.relay.manual.reconnect = tmp.relay.manual.reconnect;
	network_.relay.manual.stop = tmp.relay.manual.stop;
	network_.relay.automatic.reconnect = tmp.relay.automatic.reconnect;
	network_.relay.automatic.stop = tmp.relay.automatic.stop;

	InitControls();
}
